regina::NL31Pillow Class Reference
Standard Triangulations and Subcomplexes

Represents a triangular pillow L(3,1) component of a triangulation. More...

`#include <subcomplex/nl31pillow.h>`

Inheritance diagram for regina::NL31Pillow:

## Public Member Functions

virtual | ~NL31Pillow ()
| Destroys this structure. More...
NL31Pillow * | clone () const
| Returns a newly created clone of this structure. More...
NTetrahedron * | getTetrahedron (int whichTet) const
| Returns one of the two tetrahedra involved in this structure. More...
unsigned | getInteriorVertex (int whichTet) const
| Returns the vertex number of the given tetrahedron corresponding to the degree three vertex in the interior of the triangular pillow. More...
NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Input and Output
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NL31Pillow * | isL31Pillow (const NComponent *comp)
| Determines if the given triangulation component is a triangular pillow L(3,1). More...
static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Detailed Description

Represents a triangular pillow L(3,1) component of a triangulation.

A triangular pillow L(3,1) is a two-tetrahedron two-vertex triangulation of the lens space L(3,1) formed as follows.

A triangular pillow is formed from two tetrahedra with a single degree three vertex in the interior of the pillow. The two boundary triangles of this pillow are then identified with a one-third twist.

All optional NStandardTriangulation routines are implemented for this class.

## Constructor & Destructor Documentation

regina::NL31Pillow::~NL31Pillow | ( |  | ) |

inline virtual

Destroys this structure.

## Member Function Documentation

NL31Pillow* regina::NL31Pillow::clone | ( |  | ) | const

Returns a newly created clone of this structure.

Returns
  a newly created clone.

std::string regina::ShareableObject::detail | ( |  | ) | const

inherited

Returns the output from writeTextLong() as a string.

Returns
  a long text representation of this object.

NAbelianGroup* regina::NL31Pillow::getHomologyH1 | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling NTriangulation::getHomologyH1() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this NStandardTriangulation describes an entire NTriangulation (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling NTriangulation::getHomologyH1() upon the associated real triangulation.

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NStandardTriangulation.

unsigned regina::NL31Pillow::getInteriorVertex | ( | int | whichTet | ) | const

inline

Returns the vertex number of the given tetrahedron corresponding to the degree three vertex in the interior of the triangular pillow.

See the general class notes for further details.

The specific tetrahedron to examine is determined by the argument whichTet; this will be the tetrahedron `getTetrahedron(whichTet)`.

Parameters

  whichTet | specifies which tetrahedron to examine; this must be either 0 or 1.

Returns
  the vertex of tetrahedron whichTet corresponding to the vertex in the interior of the triangular pillow; this will be between 0 and 3 inclusive.

NManifold* regina::NL31Pillow::getManifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::NStandardTriangulation.

std::string regina::NStandardTriangulation::getName | ( |  | ) | const

inherited

Returns the name of this specific triangulation as a human-readable string.

Returns
  the name of this triangulation.

NTetrahedron * regina::NL31Pillow::getTetrahedron | ( | int | whichTet | ) | const

inline

Returns one of the two tetrahedra involved in this structure.

Parameters

  whichTet | specifies which tetrahedron to return; this must be either 0 or 1.

Returns
  the requested tetrahedron.

std::string regina::NStandardTriangulation::getTeXName | ( |  | ) | const

inherited

Returns the name of this specific triangulation in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the name of this triangulation in TeX format.

static NL31Pillow* regina::NL31Pillow::isL31Pillow | ( | const NComponent * | comp | ) |

static

Determines if the given triangulation component is a triangular pillow L(3,1).

Parameters

  comp | the triangulation component to examine.

Returns
  a newly created structure containing details of the triangular pillow L(3,1), or `null` if the given component is not a triangular pillow L(3,1).

static NStandardTriangulation* regina::NStandardTriangulation::isStandardTriangulation | ( | NComponent * | component | ) |

static inherited

Determines whether the given component represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given component must have the same corresponding boundary triangles, i.e., the component cannot have any further identifications of these boundary triangles with each other.

Note that the triangulation-based routine isStandardTriangulation(NTriangulation*) may recognise more triangulations than this routine, since passing an entire triangulation allows access to more information.

Parameters

  component | the triangulation component under examination.

Returns
  the details of the standard triangulation if the given component is recognised, or 0 otherwise.

static NStandardTriangulation* regina::NStandardTriangulation::isStandardTriangulation | ( | NTriangulation * | tri | ) |

static inherited

Determines whether the given triangulation represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given triangulation must have the same corresponding boundary triangles, i.e., the triangulation cannot have any further identifications of these boundary triangles with each other.

This routine may recognise more triangulations than the component-based isStandardTriangulation(NComponent*), since passing an entire triangulation allows access to more information.

Parameters

  tri | the triangulation under examination.

Returns
  the details of the standard triangualation if the given triangulation is recognised, or 0 otherwise.

std::string regina::ShareableObject::str | ( |  | ) | const

inherited

Returns the output from writeTextShort() as a string.

Python:
  This implements the `__str__()` function.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toString | ( |  | ) | const

inline inherited

A deprecated alias for str(), which returns the output from writeTextShort() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type str() instead.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toStringLong | ( |  | ) | const

inline inherited

A deprecated alias for detail(), which returns the output from writeTextLong() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type detail() instead.

Returns
  a long text representation of this object.

std::ostream & regina::NL31Pillow::writeName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

std::ostream & regina::NL31Pillow::writeTeXName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

void regina::NL31Pillow::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

void regina::NStandardTriangulation::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

The documentation for this class was generated from the following file:

- subcomplex/nl31pillow.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).